summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorMike Frysinger <vapier@gentoo.org>2005-11-19 05:22:18 +0000
committerMike Frysinger <vapier@gentoo.org>2005-11-19 05:22:18 +0000
commit426e0bdd38550800fda0d73aa58fe6900c06cd43 (patch)
treec503696cf55bacefe486c51c2d39222426ccdff8 /sys-devel/gcc-config/files
parentAdd patch to fix compilation with gcc4. (diff)
downloadgentoo-2-426e0bdd38550800fda0d73aa58fe6900c06cd43.tar.gz
gentoo-2-426e0bdd38550800fda0d73aa58fe6900c06cd43.tar.bz2
gentoo-2-426e0bdd38550800fda0d73aa58fe6900c06cd43.zip
old
Diffstat (limited to 'sys-devel/gcc-config/files')
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.10-r10
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r30
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r40
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.120
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r10
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r20
-rw-r--r--sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r30
-rwxr-xr-xsys-devel/gcc-config/files/gcc-config-1.3.10525
-rwxr-xr-xsys-devel/gcc-config/files/gcc-config-1.3.11599
-rw-r--r--sys-devel/gcc-config/files/wrapper-1.4.5.c409
-rw-r--r--sys-devel/gcc-config/files/wrapper-1.4.6.c409
11 files changed, 0 insertions, 1942 deletions
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.10-r1 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.10-r1
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.10-r1
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r3 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r3
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r3
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r4 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r4
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.11-r4
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.12
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r1 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r1
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r1
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r2 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r2
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r2
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r3 b/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r3
deleted file mode 100644
index e69de29bb2d1..000000000000
--- a/sys-devel/gcc-config/files/digest-gcc-config-1.3.12-r3
+++ /dev/null
diff --git a/sys-devel/gcc-config/files/gcc-config-1.3.10 b/sys-devel/gcc-config/files/gcc-config-1.3.10
deleted file mode 100755
index 220e81103c9b..000000000000
--- a/sys-devel/gcc-config/files/gcc-config-1.3.10
+++ /dev/null
@@ -1,525 +0,0 @@
-#!/bin/bash
-# Copyright 1999-2005 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/sys-devel/gcc-config/files/gcc-config-1.3.10,v 1.11 2005/04/28 23:42:25 vapier Exp $
-
-trap ":" INT QUIT TSTP
-
-source /sbin/functions.sh || {
- echo "$0: Could not source /sbin/functions.sh!"
- exit 1
-}
-umask 022
-
-usage() {
-cat << "USAGE_END"
-Usage: gcc-config [options] [CC Profile]
-Change the current cc/gcc profile, or give info about profiles.
-
-Options:
- -O, --use-old Use the old profile if one was selected.
- -P, --use-portage-chost Only set to given profile if its CHOST is the
- same as that set for portage in /etc/make.conf
- (or one of other portage config files...).
- -c, --get-current-profile Print current used gcc profile.
- -l, --list-profiles Print a list of available profiles.
- -E, --print-environ Print environment that can be used to setup the
- current gcc profile, or a specified one.
- -B, --get-bin-path Print path where binaries of the given/current
- profile are located.
- -L, --get-lib-path Print path where libraries of the given/current
- profile are located.
- -X, --get-stdcxx-incdir Print path where g++ include files of the
- given/current profile are located.
-
-Profile names are of the form: <CHOST>-<gcc version>
-For example: i686-pc-linux-gnu-3.2.1
-USAGE_END
- exit $1
-}
-[[ $# -lt 1 ]] && usage 1
-
-find_path() {
- [[ -z $1 ]] && return 0
-
- local fullpath="$(type -P $1)"
-
- if [[ -x ${fullpath} ]] ; then
- echo "${fullpath}"
- return 0
- fi
-
- for x in /bin /sbin /usr/bin /usr/sbin /usr/local/bin /usr/local/sbin ; do
- if [[ -x ${x}/$1 ]] && [[ -r ${x}/$1 ]] ; then
- echo "${x}/$1"
- return 0
- fi
- done
-
- return 0
-}
-
-cmd_setup() {
- # Sourcing /etc/env.d/gcc/${CC_COMP} is going to mess up
- # PATH among things...
- CP=$(find_path cp)
- RM=$(find_path rm)
- MV=$(find_path mv)
- LN=$(find_path ln)
- CAT=$(find_path cat)
- AWK=$(find_path gawk)
- GREP=$(find_path grep)
- FIND=$(find_path find)
- CHMOD=$(find_path chmod)
- TOUCH=$(find_path touch)
- PORTAGEQ=$(find_path portageq)
- ENV_UPDATE=$(find_path env-update)
-}
-
-get_real_chost() {
- [[ -n ${REAL_CHOST} ]] && return 0
-
- export REAL_CHOST=$(env -i ${PORTAGEQ} envvar CHOST)
-
- if [[ -z ${REAL_CHOST} ]] ; then
- eerror "$0: Could not get portage CHOST!"
- return 1
- fi
-}
-
-is_cross_compiler() {
- get_real_chost
- [[ ${CC_COMP/${REAL_CHOST}} == ${CC_COMP} ]]
-}
-
-switch_profile() {
- local MY_LDPATH=
- local GCC_PROFILES=
- local OLD_CC_COMP=
- local GCC_BIN_PATH=
-
- if [[ "$(id -u)" -ne 0 ]] ; then
- eerror "$0: Must be root."
- exit 1
- fi
-
- ebegin "Switching to ${CC_COMP} compiler"
-
- # Sourcing /etc/env.d/gcc/${CC_COMP} is going to mess up
- # PATH among things...
- cmd_setup
-
- if ! is_cross_compiler ; then
- # Order our profiles to have the default first ...
- # We do this so that we can have them ordered with default
- # first in /etc/ld.so.conf, as the logical is that all
- # compilers for default CHOST will be used to compile stuff,
- # and thus we want all their lib paths in /etc/ld.so.conf ...
- get_real_chost
- GCC_PROFILES="$(${FIND} "${GCC_ENV_D}" -maxdepth 1 -name "${REAL_CHOST}-*" -a ! -name "${CC_COMP}")"
- GCC_PROFILES="${GCC_ENV_D}/${CC_COMP} ${GCC_PROFILES}"
-
- # Extract all LDPATH's for our CHOST
- MY_LDPATH=""
- for x in ${GCC_PROFILES} ; do
- if [[ -f ${x} ]] ; then
- source "${x}"
-
- # Handle LDPATH's that have multiple directories
- local old_IFS="${IFS}"
- export IFS=":"
- local sub_ldpath=
- for sub_ldpath in ${LDPATH} ; do
- if [[ -d ${sub_ldpath} ]] ; then
- if [[ ${MY_LDPATH/:${sub_ldpath}} == ${MY_LDPATH} ]] ; then
- MY_LDPATH="${MY_LDPATH}:${sub_ldpath}"
- fi
- fi
- done
- export IFS="${old_IFS}"
- fi
- done
- MY_LDPATH="${MY_LDPATH:1}" # trim leading :
- fi
-
- # Setup things properly again for this profile
- unset GCC_SPECS LDPATH
- source "${GCC_ENV_D}/${CC_COMP}"
- OLD_CC_COMP=$(get_current_profile)
- CTARGET="${CTARGET:-${REAL_CHOST}}"
-
- # What kind of env.d entry are we going to generate ?
- if is_cross_compiler ; then
- # Only keep PATH/ROOTPATH
- ${AWK} '/^(PATH|ROOTPATH)=/ {print $0}' \
- "${GCC_ENV_D}/${CC_COMP}" > "${ENV_D}/05gcc-${CTARGET}"
-
- echo "CURRENT=${CC_COMP}" > "${GCC_ENV_D}/config-${CTARGET}"
- else
- # Pass all by default
- ${AWK} '!/^(STDCXX_INCDIR|LDPATH|CC|CXX|CTARGET|GCCBITS|GCC_SPECS)=/ {print $0}' \
- "${GCC_ENV_D}/${CC_COMP}" > "${ENV_D}/05gcc"
- echo "LDPATH=\"${MY_LDPATH}\"" >> "${ENV_D}/05gcc"
- if [[ -n ${GCC_SPECS} ]] && [[ -e ${ROOT}/${GCC_SPECS} ]] ; then
- echo "GCC_SPECS=\"${GCC_SPECS}\"" >> "${ENV_D}/05gcc"
- else
- # People need to rebuild their gcc or setting GCC_SPECS to
- # "" will cause issues again :(
- if [[ ${ROOT} != "/" ]] ; then
- echo "GCC_SPECS=\"\"" >> "${ENV_D}/05gcc"
- else
- if ! GCC_SPECS="" /usr/bin/gcc -v &>/dev/null ; then
- echo
- ewarn "Your gcc has a bug with GCC_SPECS."
- ewarn "Please re-emerge gcc."
- ewarn "http://bugs.gentoo.org/show_bug.cgi?id=68395"
- echo
- else
- echo "GCC_SPECS=\"\"" >> "${ENV_D}/05gcc"
- fi
- fi
- fi
-
- echo "CURRENT=${CC_COMP}" > "${GCC_ENV_D}/config"
- fi
-
- # Save PATH
- GCC_BIN_PATH="${PATH}"
- # Fix environment
- source /etc/profile
- umask 022
-
- # Update the wrappers for this profile
- local native="gcc cpp cc c++ g++ f77 g77 gcj"
- is_cross_compiler && native=""
- for x in ${native} ${CTARGET}-{gcc,c++,g++,f77,g77,gcj} ; do
- # Make sure we have no stale wrappers
- ${RM} -f "${ROOT}/usr/bin/${x}"
- [[ ${x:${#x}-3} == "gcc" || ${x:${#x}-3} == "g++" ]] \
- && ${RM} -f "${ROOT}/usr/bin/${x}"{32,64}
-
- # Only install a wrapper if the binary exists ...
- # We want to figure out the 'reference file' for each
- # wrapper (the binary we're 'wrapping') so that we can
- # sync mtimes together. This makes things like ccache
- # happy. See Bug #70548 for more info.
- local ref=${ROOT}/${GCC_BIN_PATH}/${x}
- [[ ${x} == "cc" ]] && ref=${ROOT}/${GCC_BIN_PATH}/gcc
- if [[ -x ${ref} ]] ; then
- ${CP} -f "${ROOT}/usr/lib/misc/gcc-config" \
- "${ROOT}/usr/bin/${x}"
- ${TOUCH} -r "${ref}" "${ROOT}/usr/bin/${x}"
-
- # Install 32bit and 64bit wrappers if need be
- # This should probably get folded back into the wrapper ...
- if [[ ${x:${#x}-3} == "gcc" ]] || [[ ${x:${#x}-3} == "g++" ]] ; then
- for bits in ${GCCBITS} ; do
- ${CP} -f "${ROOT}/usr/lib/misc/gcc-config" \
- "${ROOT}/usr/bin/${x}${bits}"
- done
- fi
- fi
- done
- # Only install cpp if switching to a native one
- if ! is_cross_compiler && [[ ${CTARGET} != *-solaris* ]] ; then
- ${RM} -f "${ROOT}/lib/cpp"
- ${CP} -f "${ROOT}/usr/lib/misc/gcc-config" "${ROOT}/lib/cpp"
- fi
-
- # We need to make sure that libgcc_s.so / libunwind.so make it into /lib.
- # On many systems (x86/amd64/etc...), this will probably never matter,
- # but on other systems (arm/mips/etc...), this is quite critical.
- # http://bugs.gentoo.org/show_bug.cgi?id=60190
- #
- # Don't copy the library if we're being called by portage because
- # this may cause python to start segfaulting all over the place
- # since on many arches, it uses libgcc_s.so.
- if [[ -z ${PORTAGE_CALLER} ]] && ! is_cross_compiler; then
- for multilib in $(${ROOT}/${GCC_BIN_PATH}/gcc -print-multi-lib); do
- multiarg=${multilib#*;}
- multiarg=${multiarg/@/-}
- multilibdir=${multilib%;*}
- libdir="lib/$(${ROOT}/${GCC_BIN_PATH}/gcc ${multiarg} -print-multi-os-directory)"
- for gcclib in gcc_s unwind ; do
- if [[ -e ${ROOT}/${LDPATH}/${multildir}/lib${gcclib}.so ]]; then
- ${RM} -f "${ROOT}/${libdir}"/lib${gcclib}.so*
- ${CP} -pP "${ROOT}/${LDPATH}/${multilibdir}"/lib${gcclib}.so* "${ROOT}/${libdir}"/
- fi
- done
- done
- unset multilib
- unset multilibdir
- unset multiarg
- unset libdir
- fi
-
- if [[ ${ROOT} == "/" ]] && [[ ${OLD_CC_COMP} != ${CC_COMP} ]] ; then
- ${ENV_UPDATE} &>/dev/null
- fi
-
- eend 0
-
- if [[ ${ROOT} == "/" ]] && [[ ${OLD_CC_COMP} != ${CC_COMP} ]] ; then
- echo
- ewarn "If you intend to use the gcc from the new profile in an already"
- ewarn "running shell, please remember to do:"
- echo
- ewarn " # source /etc/profile"
- echo
- fi
-
- return 0
-}
-
-get_current_profile() {
- local conf="${GCC_ENV_D}/config"
- if [[ -n ${CTARGET} ]] ; then
- conf="${conf}-${CTARGET}"
- elif [[ -f ${GCC_ENV_D}/config-${CC_COMP} ]] ; then
- conf="${conf}-${CC_COMP}"
- fi
-
- if [[ ! -f ${conf} ]] ; then
- eerror "$0: No gcc profile is active!"
- return 1
- fi
-
- source "${conf}"
-
- if [[ -z ${CURRENT} ]] ; then
- eerror "$0: No gcc profile is active!"
- return 1
- fi
-
- echo "${CURRENT}"
-
- return 0
-}
-
-list_profiles() {
- local i=1
-
- if [[ ! -f ${GCC_ENV_D}/config ]] ; then
- eerror "$0: No gcc profile is active; please select one!"
- else
- get_current_profile >/dev/null
- fi
-
- if [[ ${ROOT} != "/" ]] ; then
- echo "Using gcc-config info in ${ROOT}"
- fi
- for x in "${GCC_ENV_D}"/* ; do
- if [[ -f ${x} ]] && [[ ${x/\/config} == ${x} ]] ; then
- x=${x##*/}
- [[ ${x} == ${CURRENT} ]] && x="${x} *"
- echo "[${i}] ${x}"
- i=$((i + 1))
- fi
- done
-}
-
-print_environ() {
- local OLDPATH="${PATH}"
- local ENV_CMD=
- local SET_ELEMENT=
-
- source "${GCC_ENV_D}/${CC_COMP}"
-
- case ${SHELL} in
- */csh|*/tsch)
- ENV_CMD="setenv"
- SET_ELEMENT=" "
- ;;
- *)
- ENV_CMD="export"
- SET_ELEMENT="="
- ;;
- esac
-
- echo "${ENV_CMD} PATH${SET_ELEMENT}\"${PATH}:${OLDPATH}\""
-}
-
-get_bin_path() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${PATH}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-get_lib_path() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${LDPATH}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-get_stdcxx_incdir() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${LDPATH}/include/${STDCXX_INCDIR}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-NEED_ACTION="yes"
-DOIT="switch_profile"
-CHECK_CHOST="no"
-
-CC_COMP=
-[[ -z ${ROOT} ]] && ROOT="/"
-[[ ${ROOT:-1} != "/" ]] && ROOT="${ROOT}/"
-ENV_D="${ROOT}etc/env.d"
-GCC_ENV_D="${ENV_D}/gcc"
-
-for x in "$@" ; do
- case "${x}" in
- # Only use specified compiler if one is not already selected.
- -O|--use-old)
- if get_current_profile &>/dev/null ; then
- CC_COMP="$(get_current_profile)"
- fi
- ;;
- -P|--use-portage-chost)
- CHECK_CHOST="yes"
- ;;
- -c|--get-current-profile)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_current_profile"
- fi
- ;;
- -l|--list-profiles)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="list_profiles"
- fi
- ;;
- -E|--print-environ)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="print_environ"
- fi
- ;;
- -B|--get-bin-path)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_bin_path"
- fi
- ;;
- -L|--get-lib-path)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_lib_path"
- fi
- ;;
- -X|--get-stdcxx-incdir)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_stdcxx_incdir"
- fi
- ;;
- -h|--help)
- usage 0
- exit 0
- ;;
- -v|--version)
- echo "gcc-config-PORTAGE-VERSION"
- exit 0
- ;;
- -*)
- eerror "$0: Invalid switch! Run $0 without parameters for help."
- exit 1
- ;;
- *)
- if [[ -z ${CC_COMP} ]] ; then
- if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
- # User gave us a # representing the profile
- i=1
- for y in "${GCC_ENV_D}"/* ; do
- [[ ${y/\/config} != ${y} ]] && continue
-
- if [[ -f ${y} ]] && [[ ${x} == ${i} ]] ; then
- CC_COMP="${y##*/}"
- break
- fi
- i=$((i + 1))
- done
- else
- # User gave us a full HOST-gccver
- x=${x##*/}
- if [[ ${DOIT} != "get_current_profile" ]] && \
- [[ ! -f ${GCC_ENV_D}/${x} ]]
- then
- eerror "$0: Could not locate '$x' in '${GCC_ENV_D}/'!"
- exit 1
- fi
- CC_COMP="${x}"
- fi
- else
- eerror "$0: Too many arguments! Run $0 without parameters for help."
- exit 1
- fi
- ;;
- esac
-done
-
-if [[ ${DOIT} == "switch_profile" ]] && [[ -z ${CC_COMP} ]] ; then
- usage 1
-fi
-
-if [[ -z ${CC_COMP} ]] ; then
- if get_current_profile &>/dev/null
- then
- CC_COMP="$(get_current_profile)"
- else
- list_profiles
- exit 1
- fi
-fi
-
-if [[ ${DOIT} != "get_current_profile" ]] ; then
- GCC_LIB=$(source "${GCC_ENV_D}/${CC_COMP}"
- cmd_setup
- echo ${LDPATH} | ${AWK} -F/ '{ print "/"$2"/"$3"/"$4"/" }')
-
- CC_COMP_TARGET=$(echo ${CC_COMP} | awk -F- '{ print $1"-"$2"-"$3"-"$4 }')
- CC_COMP_VERSION=${CC_COMP/${CC_COMP_TARGET}-/}
-
- if [[ ! -d ${ROOT}/${GCC_LIB}/${CC_COMP_TARGET}/${CC_COMP_VERSION} ]]; then
- CC_COMP_VERSION=${CC_COMP_VERSION%-*}
- fi
-
- if [[ ! -d ${ROOT}/${GCC_LIB}/${CC_COMP_TARGET}/${CC_COMP_VERSION} ]] || \
- [[ ! -f ${GCC_ENV_D}/${CC_COMP} ]]
- then
- eerror "$0: Profile does not exist or invalid setting for ${GCC_ENV_D}/${CC_COMP}" 1>&2
- #exit 1
- fi
-fi
-
-if [[ ${CHECK_CHOST} == "yes" ]] ; then
- # Chosen CHOST are not the same as the real CHOST according to
- # make.conf, and --use-portage-chost option was given, so do nothing
- get_real_chost
- CC_COMP_TARGET=$(echo ${CC_COMP} | awk -F- '{ print $1"-"$2"-"$3"-"$4 }')
- [[ ${CC_COMP_TARGET} != ${REAL_CHOST} ]] && exit 0
-fi
-
-eval ${DOIT}
-
-
-# vim:ts=4
diff --git a/sys-devel/gcc-config/files/gcc-config-1.3.11 b/sys-devel/gcc-config/files/gcc-config-1.3.11
deleted file mode 100755
index ae32f91667a0..000000000000
--- a/sys-devel/gcc-config/files/gcc-config-1.3.11
+++ /dev/null
@@ -1,599 +0,0 @@
-#!/bin/bash
-# Copyright 1999-2005 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# $Header: /var/cvsroot/gentoo-x86/sys-devel/gcc-config/files/gcc-config-1.3.11,v 1.7 2005/07/10 06:18:55 vapier Exp $
-
-trap ":" INT QUIT TSTP
-
-source /sbin/functions.sh || {
- echo "$0: Could not source /sbin/functions.sh!"
- exit 1
-}
-umask 022
-
-usage() {
-cat << "USAGE_END"
-Usage: gcc-config [options] [CC Profile]
-Change the current cc/gcc profile, or give info about profiles.
-
-Options:
- -O, --use-old Use the old profile if one was selected.
- -f, --force Make sure all config files are regenerated.
- -P, --use-portage-chost Only set to given profile if its CHOST is the
- same as that set for portage in /etc/make.conf
- (or one of other portage config files...).
- -c, --get-current-profile Print current used gcc profile.
- -l, --list-profiles Print a list of available profiles.
- -E, --print-environ Print environment that can be used to setup the
- current gcc profile, or a specified one.
- -B, --get-bin-path Print path where binaries of the given/current
- profile are located.
- -L, --get-lib-path Print path where libraries of the given/current
- profile are located.
- -X, --get-stdcxx-incdir Print path where g++ include files of the
- given/current profile are located.
-
-Profile names are of the form: <CHOST>-<gcc version>
-For example: i686-pc-linux-gnu-3.2.1
-USAGE_END
- exit $1
-}
-[[ $# -lt 1 ]] && usage 1
-
-find_path() {
- [[ -z $1 ]] && return 0
-
- local fullpath="$(type -P $1)"
-
- if [[ -x ${fullpath} ]] ; then
- echo "${fullpath}"
- return 0
- fi
-
- for x in /bin /sbin /usr/bin /usr/sbin /usr/local/bin /usr/local/sbin ; do
- if [[ -x ${x}/$1 ]] && [[ -r ${x}/$1 ]] ; then
- echo "${x}/$1"
- return 0
- fi
- done
-
- return 0
-}
-
-cmd_setup() {
- # Sourcing /etc/env.d/gcc/${CC_COMP} is going to mess up
- # PATH among things...
- CP=$(find_path cp)
- RM=$(find_path rm)
- MV=$(find_path mv)
- LN=$(find_path ln)
- CAT=$(find_path cat)
- ENV=$(find_path env)
- SED=$(find_path sed)
- AWK=$(find_path gawk)
- GREP=$(find_path grep)
- FIND=$(find_path find)
- CHMOD=$(find_path chmod)
- TOUCH=$(find_path touch)
- PYTHON=$(find_path python)
- PORTAGEQ=$(find_path portageq)
- ENV_UPDATE=$(find_path env-update)
-}
-
-get_real_chost() {
- [[ -n ${REAL_CHOST} ]] && return 0
-
- # make sure portage isnt broken
- if ${PYTHON} -V &>/dev/null ; then
- export REAL_CHOST=$(${ENV} -i ${PORTAGEQ} envvar CHOST 2>/dev/null)
- else
- export REAL_CHOST=$(source "${ROOT}"/etc/make.conf ; echo ${CHOST})
- fi
-
- if [[ -z ${REAL_CHOST} ]] ; then
- eerror "$0: Could not get portage CHOST!"
- return 1
- fi
-}
-
-is_cross_compiler() {
- get_real_chost
- [[ ${CC_COMP/${REAL_CHOST}} == ${CC_COMP} ]]
-}
-
-switch_profile() {
- local MY_LDPATH=
- local GCC_PROFILES=
- local OLD_CC_COMP=
- local GCC_BIN_PATH=
-
- if [[ "$(id -u)" -ne 0 ]] ; then
- eerror "$0: Must be root."
- exit 1
- fi
-
- ebegin "Switching to ${CC_COMP} compiler"
-
- # Sourcing /etc/env.d/gcc/${CC_COMP} is going to mess up
- # PATH among things...
- cmd_setup
-
- if ! is_cross_compiler ; then
- # Order our profiles to have the default first ...
- # We do this so that we can have them ordered with default
- # first in /etc/ld.so.conf, as the logical is that all
- # compilers for default CHOST will be used to compile stuff,
- # and thus we want all their lib paths in /etc/ld.so.conf ...
- get_real_chost
- GCC_PROFILES="$(${FIND} "${GCC_ENV_D}" -maxdepth 1 -name "${REAL_CHOST}-*" -a ! -name "${CC_COMP}")"
- GCC_PROFILES="${GCC_ENV_D}/${CC_COMP} ${GCC_PROFILES}"
-
- # Extract all LDPATH's for our CHOST
- MY_LDPATH=""
- for x in ${GCC_PROFILES} ; do
- if [[ -f ${x} ]] ; then
- source "${x}"
-
- # Handle LDPATH's that have multiple directories
- local old_IFS="${IFS}"
- export IFS=":"
- local sub_ldpath=
- for sub_ldpath in ${LDPATH} ; do
- if [[ -d ${sub_ldpath} ]] ; then
- if [[ ${MY_LDPATH/:${sub_ldpath}} == ${MY_LDPATH} ]] ; then
- MY_LDPATH="${MY_LDPATH}:${sub_ldpath}"
- fi
- fi
- done
- export IFS="${old_IFS}"
- fi
- done
- MY_LDPATH="${MY_LDPATH:1}" # trim leading :
- fi
-
- # Setup things properly again for this profile
- unset GCC_SPECS LDPATH
- source "${GCC_ENV_D}/${CC_COMP}"
- OLD_CC_COMP=$(get_current_profile)
- CTARGET="${CTARGET:-${REAL_CHOST}}"
-
- # What kind of env.d entry are we going to generate ?
- if is_cross_compiler ; then
- # Only keep PATH/ROOTPATH
- ${AWK} '/^(PATH|ROOTPATH)=/ {print $0}' \
- "${GCC_ENV_D}/${CC_COMP}" > "${ENV_D}/05gcc-${CTARGET}"
-
- echo "CURRENT=${CC_COMP}" > "${GCC_ENV_D}/config-${CTARGET}"
- else
- # Pass all by default
- ${AWK} '!/^(STDCXX_INCDIR|LDPATH|CC|CXX|CTARGET|GCCBITS|GCC_SPECS)=/ {print $0}' \
- "${GCC_ENV_D}/${CC_COMP}" > "${ENV_D}/05gcc"
- echo "LDPATH=\"${MY_LDPATH}\"" >> "${ENV_D}/05gcc"
- if [[ -n ${GCC_SPECS} ]] && [[ -e ${ROOT}/${GCC_SPECS} ]] ; then
- echo "GCC_SPECS=\"${GCC_SPECS}\"" >> "${ENV_D}/05gcc"
- else
- # People need to rebuild their gcc or setting GCC_SPECS to
- # "" will cause issues again :(
- if [[ ${ROOT} != "/" ]] ; then
- echo "GCC_SPECS=\"\"" >> "${ENV_D}/05gcc"
- else
- if ! GCC_SPECS="" /usr/bin/gcc -v &>/dev/null ; then
- echo
- ewarn "Your gcc has a bug with GCC_SPECS."
- ewarn "Please re-emerge gcc."
- ewarn "http://bugs.gentoo.org/show_bug.cgi?id=68395"
- echo
- else
- echo "GCC_SPECS=\"\"" >> "${ENV_D}/05gcc"
- fi
- fi
- fi
-
- echo "CURRENT=${CC_COMP}" > "${GCC_ENV_D}/config"
- fi
-
- # Save PATH
- GCC_BIN_PATH="${PATH}"
- # Fix environment
- source /etc/profile
- umask 022
-
- # Update the wrappers for this profile
- local native="gcc cpp cc c++ g++ f77 g77 gcj"
- is_cross_compiler && native=""
- for x in ${native} ${CTARGET}-{gcc,c++,g++,f77,g77,gcj} ; do
- # Make sure we have no stale wrappers
- ${RM} -f "${ROOT}/usr/bin/${x}"
- [[ ${x:${#x}-3} == "gcc" || ${x:${#x}-3} == "g++" ]] \
- && ${RM} -f "${ROOT}/usr/bin/${x}"{32,64}
-
- # Only install a wrapper if the binary exists ...
- # We want to figure out the 'reference file' for each
- # wrapper (the binary we're 'wrapping') so that we can
- # sync mtimes together. This makes things like ccache
- # happy. See Bug #70548 for more info.
- local ref=${ROOT}/${GCC_BIN_PATH}/${x}
- [[ ${x} == "cc" ]] && ref=${ROOT}/${GCC_BIN_PATH}/gcc
- [[ ${x} == "f77" ]] && ref=${ROOT}/${GCC_BIN_PATH}/g77
- if [[ -x ${ref} ]] ; then
- ${CP} -f "${ROOT}/usr/lib/misc/gcc-config" \
- "${ROOT}/usr/bin/${x}"
- ${TOUCH} -r "${ref}" "${ROOT}/usr/bin/${x}"
-
- # Install 32bit and 64bit wrappers if need be
- # This should probably get folded back into the wrapper ...
- if [[ ${x:${#x}-3} == "gcc" ]] || [[ ${x:${#x}-3} == "g++" ]] ; then
- for bits in ${GCCBITS} ; do
- ${CP} -f "${ROOT}/usr/lib/misc/gcc-config" \
- "${ROOT}/usr/bin/${x}${bits}"
- done
- fi
- fi
- done
- # Only install cpp if switching to a native one
- if ! is_cross_compiler && [[ ${CTARGET} != *-solaris* ]] ; then
- ${RM} -f "${ROOT}/lib/cpp"
- ${CP} -f "${ROOT}/usr/lib/misc/gcc-config" "${ROOT}/lib/cpp"
- fi
-
- # We need to make sure that libgcc_s.so / libunwind.so make it into /lib.
- # On many systems (x86/amd64/etc...), this will probably never matter,
- # but on other systems (arm/mips/etc...), this is quite critical.
- # http://bugs.gentoo.org/show_bug.cgi?id=60190
- #
- # Don't copy the library if we're being called by portage because
- # this may cause python to start segfaulting all over the place
- # since on many arches, it uses libgcc_s.so.
- if [[ -z ${PORTAGE_CALLER} ]] && ! is_cross_compiler; then
- for multilib in $(${ROOT}/${GCC_BIN_PATH}/gcc -print-multi-lib); do
- multiarg=${multilib#*;}
- multiarg=${multiarg/@/-}
- multilibdir=${multilib%;*}
- libdir="lib/$(${ROOT}/${GCC_BIN_PATH}/gcc ${multiarg} -print-multi-os-directory)"
- for gcclib in gcc_s unwind ; do
- if [[ -e ${ROOT}/${LDPATH}/${multildir}/lib${gcclib}.so ]]; then
- ${RM} -f "${ROOT}/${libdir}"/lib${gcclib}.so*
- ${CP} -pP "${ROOT}/${LDPATH}/${multilibdir}"/lib${gcclib}.so* "${ROOT}/${libdir}"/
- fi
- done
- done
- unset multilib
- unset multilibdir
- unset multiarg
- unset libdir
- fi
-
- if [[ ${ROOT} == "/" ]] && [[ ${OLD_CC_COMP} != ${CC_COMP} || ${FORCE} == "yes" ]] ; then
- # in case python is broken ...
- if ! ${ENV_UPDATE} &>/dev/null ; then
- echo ""
- ewarn "env-update failed to work properly; making sure ld.so.conf paths"
- ewarn "are setup properly. Please rerun gcc-config with the -f option."
- echo ""
- ${GREP} -h ^LDPATH= "${ROOT}"/etc/env.d/05gcc \
- | ${SED} -e 's:^LDPATH=::' -e 's:"::g' -e 's|:|\n|g' \
- >> /etc/ld.so.conf
- ldconfig
- fi
- fi
-
- eend 0
-
- if [[ ${ROOT} == "/" ]] && [[ ${OLD_CC_COMP} != ${CC_COMP} ]] ; then
- echo
- ewarn "If you intend to use the gcc from the new profile in an already"
- ewarn "running shell, please remember to do:"
- echo
- ewarn " # source /etc/profile"
- echo
- fi
-
- return 0
-}
-
-get_current_profile() {
- local conf="${GCC_ENV_D}/config"
- if [[ -n ${CTARGET} ]] ; then
- conf="${conf}-${CTARGET}"
- elif [[ -n ${CC_COMP} ]] && is_cross_compiler ; then
- conf="${conf}-${CC_COMP}"
- fi
-
- if [[ ! -f ${conf} ]] ; then
- eerror "$0: No gcc profile is active!"
- return 1
- fi
-
- source "${conf}"
-
- if [[ -z ${CURRENT} ]] ; then
- eerror "$0: No gcc profile is active!"
- return 1
- fi
-
- echo "${CURRENT}"
-
- return 0
-}
-
-list_profiles() {
- local i=1
-
- if [[ ! -f ${GCC_ENV_D}/config ]] ; then
- eerror "$0: No gcc profile is active; please select one!"
- else
- get_current_profile >/dev/null
- fi
-
- if [[ ${ROOT} != "/" ]] ; then
- echo "Using gcc-config info in ${ROOT}"
- fi
- for x in "${GCC_ENV_D}"/* ; do
- if [[ -f ${x} ]] && [[ ${x/\/config} == ${x} ]] ; then
- x=${x##*/}
- [[ ${x} == ${CURRENT} ]] && x="${x} *"
- echo "[${i}] ${x}"
- i=$((i + 1))
- fi
- done
-}
-
-print_environ() {
- local OLDPATH="${PATH}"
- local ENV_CMD=
- local SET_ELEMENT=
-
- source "${GCC_ENV_D}/${CC_COMP}"
-
- case ${SHELL} in
- */csh|*/tsch)
- ENV_CMD="setenv"
- SET_ELEMENT=" "
- ;;
- *)
- ENV_CMD="export"
- SET_ELEMENT="="
- ;;
- esac
-
- echo "${ENV_CMD} PATH${SET_ELEMENT}\"${PATH}:${OLDPATH}\""
-}
-
-get_bin_path() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${PATH}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-get_lib_path() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${LDPATH}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-get_stdcxx_incdir() {
- if [[ -e ${GCC_ENV_D}/${CC_COMP} ]] ; then
- source "${GCC_ENV_D}/${CC_COMP}"
- echo "${LDPATH}/include/${STDCXX_INCDIR}"
- else
- echo "no-config"
- echo "${GCC_ENV_D}/${CC_COMP} doesnt exist" 1>&2
- fi
-
- return 0
-}
-
-NEED_ACTION="yes"
-DOIT="switch_profile"
-CHECK_CHOST="no"
-FORCE="no"
-
-CC_COMP=
-[[ -z ${ROOT} ]] && ROOT="/"
-[[ ${ROOT:-1} != "/" ]] && ROOT="${ROOT}/"
-ENV_D="${ROOT}etc/env.d"
-GCC_ENV_D="${ENV_D}/gcc"
-
-for x in "$@" ; do
- case "${x}" in
- # Only use specified compiler if one is not already selected.
- -O|--use-old)
- if get_current_profile &>/dev/null ; then
- CC_COMP="$(get_current_profile)"
- fi
- ;;
- -f|--force)
- FORCE="yes"
- ;;
- -P|--use-portage-chost)
- CHECK_CHOST="yes"
- ;;
- -c|--get-current-profile)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_current_profile"
- fi
- ;;
- -l|--list-profiles)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="list_profiles"
- fi
- ;;
- -E|--print-environ)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="print_environ"
- fi
- ;;
- -B|--get-bin-path)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_bin_path"
- fi
- ;;
- -L|--get-lib-path)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_lib_path"
- fi
- ;;
- -X|--get-stdcxx-incdir)
- if [[ ${NEED_ACTION} == "yes" ]] ; then
- NEED_ACTION="no"
- DOIT="get_stdcxx_incdir"
- fi
- ;;
- -h|--help)
- usage 0
- exit 0
- ;;
- -v|--version)
- echo "gcc-config-PORTAGE-VERSION"
- exit 0
- ;;
- -*)
- eerror "$0: Invalid switch! Run $0 without parameters for help."
- exit 1
- ;;
- *)
- if [[ -z ${CC_COMP} ]] ; then
- if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
- # User gave us a # representing the profile
- i=1
- for y in "${GCC_ENV_D}"/* ; do
- [[ ${y/\/config} != ${y} ]] && continue
-
- if [[ -f ${y} ]] && [[ ${x} == ${i} ]] ; then
- CC_COMP="${y##*/}"
- break
- fi
- i=$((i + 1))
- done
- else
- # User gave us a full HOST-gccver
- x=${x##*/}
- if [[ ${DOIT} == "get_current_profile" && -z $(ls "${GCC_ENV_D}"/${x}-* 2>/dev/null) ]] || \
- [[ ${DOIT} != "get_current_profile" && ! -f ${GCC_ENV_D}/${x} ]]
- then
- eerror "$0: Could not locate '$x' in '${GCC_ENV_D}/' !"
- exit 1
- fi
- CC_COMP="${x}"
- fi
- else
- eerror "$0: Too many arguments! Run $0 without parameters for help."
- exit 1
- fi
- ;;
- esac
-done
-
-if [[ ${DOIT} == "switch_profile" ]] && [[ -z ${CC_COMP} ]] ; then
- usage 1
-fi
-
-if [[ -z ${CC_COMP} ]] ; then
- if get_current_profile &>/dev/null ; then
- CC_COMP="$(get_current_profile)"
- else
- list_profiles
- exit 1
- fi
-fi
-
-chop_gcc_ver() {
- # we want to chop off the 'version' part of the profile ...
- # possible profile names:
- # arm-unknown-linux-gnu-3.3.6
- # mipsel-unknown-linux-uclibc-3.4.4
- # sh4-gentoo-linux-uclibc-3.4.4
- # x86_64-pc-linux-gnu-3.4.3-20050110
- # x86_64-pc-linux-gnu-4.0.0-hardenednopie
- # x86_64-pc-linux-gnu-3.3.5-20050130-hardened
- # x86_64-pc-linux-gnu-4.0.1-beta20050526
- #
- # So below we will start at the end and accept everything
- # until we get to a portion where the string is just number/dots ...
- # Then we eat all the portions of just number/dots until the TARGET
- # is all that's left to us.
- echo "$@" | awk -F- '{
- foundver=0
- gccver=""
- for (i=NF; i > 0; --i) {
- if ($i ~ /^[[:digit:].]+$/) {
- gccver=$i"-"gccver
- foundver=1
- } else if (foundver == 0)
- gccver=$i"-"gccver
- else
- break
- }
- print substr(gccver,0,length(gccver)-1)
- }'
-}
-test_chop_gcc_ver() {
- local c ver host
- local clist="
- arm-unknown-linux-gnu-3.3.6
- mipsel-unknown-linux-uclibc-3.4.4
- sh4-gentoo-linux-uclibc-3.4.4
- x86_64-pc-linux-gnu-3.4.3-20050110
- x86_64-pc-linux-gnu-4.0.1-beta20050526
- x86_64-pc-linux-gnu-4.0.0-hardenednopie
- x86_64-pc-linux-gnu-3.3.5-20050130-hardened
- "
- for c in ${clist} ; do
- ver=$(chop_gcc_ver ${c})
- host=${c%-${ver}*}
- printf "%-45s %-30s %s\n" ${c} ${host} ${ver}
- done
-}
-
-if [[ ${DOIT} != "get_current_profile" ]] ; then
- GCC_LIB=$(
- source "${GCC_ENV_D}/${CC_COMP}"
- cmd_setup
- echo ${LDPATH} | ${AWK} -F/ '{ print "/"$2"/"$3"/"$4"/" }'
- )
-
- CC_COMP_VERSION=$(chop_gcc_ver ${CC_COMP})
- CC_COMP_TARGET=${CC_COMP%-${CC_COMP_VERSION}*}
-
- if [[ ! -d ${ROOT}/${GCC_LIB}/${CC_COMP_TARGET}/${CC_COMP_VERSION} ]]; then
- CC_COMP_VERSION=${CC_COMP_VERSION%-*}
- fi
-
- if [[ ! -d ${ROOT}/${GCC_LIB}/${CC_COMP_TARGET}/${CC_COMP_VERSION} ]] || \
- [[ ! -f ${GCC_ENV_D}/${CC_COMP} ]]
- then
- eerror "$0: Profile does not exist or invalid setting for ${GCC_ENV_D}/${CC_COMP}" 1>&2
- #exit 1
- fi
-fi
-
-if [[ ${CHECK_CHOST} == "yes" ]] ; then
- # Chosen CHOST are not the same as the real CHOST according to
- # make.conf, and --use-portage-chost option was given, so do nothing
- get_real_chost
- CC_COMP_VERSION=$(chop_gcc_ver ${CC_COMP})
- CC_COMP_TARGET=${CC_COMP:0:${#CC_COMP}-${#CC_COMP_VERSION}-1}
- [[ ${CC_COMP_TARGET} != ${REAL_CHOST} ]] && exit 0
-fi
-
-eval ${DOIT}
-
-
-# vim:ts=4
diff --git a/sys-devel/gcc-config/files/wrapper-1.4.5.c b/sys-devel/gcc-config/files/wrapper-1.4.5.c
deleted file mode 100644
index 4c9abdc72d50..000000000000
--- a/sys-devel/gcc-config/files/wrapper-1.4.5.c
+++ /dev/null
@@ -1,409 +0,0 @@
-/*
- * Copyright 1999-2005 Gentoo Foundation
- * Distributed under the terms of the GNU General Public License v2
- * $Header: /var/cvsroot/gentoo-x86/sys-devel/gcc-config/files/wrapper-1.4.5.c,v 1.4 2005/03/16 23:32:12 vapier Exp $
- * Author: Martin Schlemmer <azarah@gentoo.org>
- */
-
-#define _REENTRANT
-#define _GNU_SOURCE
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <sys/param.h>
-#include <unistd.h>
-#include <sys/wait.h>
-#include <libgen.h>
-#include <string.h>
-#include <stdarg.h>
-#include <errno.h>
-
-#define GCC_CONFIG "/usr/bin/gcc-config"
-#define ENVD_BASE "/etc/env.d/05gcc"
-
-struct wrapper_data {
- char name[MAXPATHLEN + 1];
- char fullname[MAXPATHLEN + 1];
- char bin[MAXPATHLEN + 1];
- char tmp[MAXPATHLEN + 1];
-
- char *path;
-};
-
-static const char *wrapper_strerror(int err, struct wrapper_data *data)
-{
- /* this app doesn't use threads and strerror
- * is more portable than strerror_r */
- strncpy(data->tmp, strerror(err), sizeof(data->tmp));
- return data->tmp;
-}
-
-static void wrapper_exit(char *msg, ...)
-{
- va_list args;
- fprintf(stderr, "gcc-config error: ");
- va_start(args, msg);
- vfprintf(stderr, msg, args);
- va_end(args);
- exit(1);
-}
-
-/* check_for_target checks in path for the file we are seeking
- * it returns 1 if found (with data->bin setup), 0 if not and
- * negative on error
- */
-static int check_for_target(char *path, struct wrapper_data *data)
-{
- struct stat sbuf;
- int result = 0;
- char str[MAXPATHLEN + 1];
- size_t len = strlen(path) + strlen(data->name) + 2;
-
- snprintf(str, len, "%s/%s", path, data->name);
-
- /* Stat possible file to check that
- * 1) it exist and is a regular file, and
- * 2) it is not the wrapper itself, and
- * 3) it is in a /gcc-bin/ directory tree
- */
- result = stat(str, &sbuf);
- if ((result == 0) && \
- ((sbuf.st_mode & S_IFREG) || (sbuf.st_mode & S_IFLNK)) && \
- (strcmp(str, data->fullname) != 0) && \
- (strstr(str, "/gcc-bin/") != 0)) {
-
- strncpy(data->bin, str, MAXPATHLEN);
- data->bin[MAXPATHLEN] = 0;
- result = 1;
- } else
- result = 0;
-
- return result;
-}
-
-static int find_target_in_path(struct wrapper_data *data)
-{
- char *token = NULL, *state;
- char str[MAXPATHLEN + 1];
-
- if (data->path == NULL) return 0;
-
- /* Make a copy since strtok_r will modify path */
- snprintf(str, MAXPATHLEN + 1, "%s", data->path);
-
- token = strtok_r(str, ":", &state);
-
- /* Find the first file with suitable name in PATH. The idea here is
- * that we do not want to bind ourselfs to something static like the
- * default profile, or some odd environment variable, but want to be
- * able to build something with a non default gcc by just tweaking
- * the PATH ... */
- while ((token != NULL) && strlen(token)) {
- if (check_for_target(token, data))
- return 1;
- token = strtok_r(NULL, ":", &state);
- }
-
- return 0;
-}
-
-/* find_target_in_envd parses /etc/env.d/05gcc, and tries to
- * extract PATH, which is set to the current profile's bin
- * directory ...
- */
-static int find_target_in_envd(struct wrapper_data *data, int cross_compile)
-{
- FILE *envfile = NULL;
- char *token = NULL, *state;
- char str[MAXPATHLEN + 1];
- char *strp = str;
- char envd_file[MAXPATHLEN + 1];
-
- if (!cross_compile) {
- snprintf(envd_file, MAXPATHLEN, "%s", ENVD_BASE);
- } else {
- char *ctarget, *end = strrchr(data->name, '-');
- if (end == NULL)
- return 0;
- ctarget = strdup(data->name);
- ctarget[end - data->name] = '\0';
- snprintf(envd_file, MAXPATHLEN, "%s-%s", ENVD_BASE, ctarget);
- free(ctarget);
- }
- envfile = fopen(envd_file, "r");
- if (envfile == NULL)
- return 0;
-
- while (0 != fgets(strp, MAXPATHLEN, envfile)) {
- /* Keep reading ENVD_FILE until we get a line that
- * starts with 'PATH='
- */
- if (((strp) && (strlen(strp) > strlen("PATH=")) &&
- !strncmp("PATH=", strp, strlen("PATH=")))) {
-
- token = strtok_r(strp, "=", &state);
- if ((token != NULL) && strlen(token))
- /* The second token should be the value of PATH .. */
- token = strtok_r(NULL, "=", &state);
- else
- goto bail;
-
- if ((token != NULL) && strlen(token)) {
- strp = token;
- /* A bash variable may be unquoted, quoted with " or
- * quoted with ', so extract the value without those ..
- */
- token = strtok(strp, "\n\"\'");
-
- while (token != NULL) {
- if (check_for_target(token, data)) {
- fclose(envfile);
- return 1;
- }
-
- token = strtok(NULL, "\n\"\'");
- }
- }
- }
- strp = str;
- }
-
-bail:
- fclose(envfile);
- return (cross_compile ? 0 : find_target_in_envd(data, 1));
-}
-
-static void find_wrapper_target(struct wrapper_data *data)
-{
- FILE *inpipe = NULL;
- char str[MAXPATHLEN + 1];
-
- if (find_target_in_path(data))
- return;
-
- if (find_target_in_envd(data, 0))
- return;
-
- /* Only our wrapper is in PATH, so
- get the CC path using gcc-config and
- execute the real binary in there... */
- inpipe = popen(GCC_CONFIG " --get-bin-path", "r");
- if (inpipe == NULL)
- wrapper_exit(
- "Could not open pipe: %s\n",
- wrapper_strerror(errno, data));
-
- if (fgets(str, MAXPATHLEN, inpipe) == 0)
- wrapper_exit(
- "Could not get compiler binary path: %s\n",
- wrapper_strerror(errno, data));
-
- strncpy(data->bin, str, sizeof(data->bin) - 1);
- data->bin[strlen(data->bin) - 1] = '/';
- strncat(data->bin, data->name, sizeof(data->bin) - 1);
- data->bin[MAXPATHLEN] = 0;
-
- pclose(inpipe);
-}
-
-/* This function modifies PATH to have gcc's bin path appended */
-static void modify_path(struct wrapper_data *data)
-{
- char *newpath = NULL, *token = NULL, *state;
- char dname_data[MAXPATHLEN + 1], str[MAXPATHLEN + 1];
- char *str2 = dname_data, *dname = dname_data;
- size_t len = 0;
-
- if (data->bin == NULL)
- return;
-
- snprintf(str2, MAXPATHLEN + 1, "%s", data->bin);
-
- if ((dname = dirname(str2)) == NULL)
- return;
-
- if (data->path == NULL)
- return;
-
- /* Make a copy since strtok_r will modify path */
- snprintf(str, MAXPATHLEN + 1, "%s", data->path);
-
- token = strtok_r(str, ":", &state);
-
- /* Check if we already appended our bin location to PATH */
- if ((token != NULL) && strlen(token)) {
- if (!strcmp(token, dname))
- return;
- }
-
- len = strlen(dname) + strlen(data->path) + 2 + strlen("PATH") + 1;
-
- newpath = (char *)malloc(len);
- if (newpath == NULL)
- wrapper_exit("out of memory\n");
- memset(newpath, 0, len);
-
- snprintf(newpath, len, "PATH=%s:%s", dname, data->path);
- putenv(newpath);
-}
-
-#define MAXNEWFLAGS 32
-#define MAXFLAGLEN 127
-
-static char **getNewArgv(char **argv, const char *newflagsStr) {
- char **newargv;
- char newflags[MAXNEWFLAGS][MAXFLAGLEN + 1];
- unsigned newflagsCount = 0;
- unsigned argc;
- unsigned i;
- char **p;
-
- unsigned s, f; /* start/finish of each flag. f points to
- * the char AFTER the end (ie the space/\0
- */
-
- /* Tokenize the flag list */
- for(s=0; s < strlen(newflagsStr); s=f+1) {
- /* Put s at the start of the next flag */
- while(newflagsStr[s] == ' ' ||
- newflagsStr[s] == '\t')
- s++;
- if(s == strlen(newflagsStr))
- break;
-
- f = s + 1;
- while(newflagsStr[f] != ' ' &&
- newflagsStr[f] != '\t' &&
- newflagsStr[f] != '\0')
- f++;
-
- /* Detect overrun */
- if(MAXFLAGLEN < f - s || MAXNEWFLAGS == newflagsCount)
- return NULL;
-
- strncpy(newflags[newflagsCount], newflagsStr + s, f - s);
- newflags[newflagsCount][f - s]='\0';
- newflagsCount++;
- }
-
- /* Calculate original argc and see if it contains -m{abi,32,64} */
- for(argc=0, p=argv; *p; p++, argc++) {
- if(newflagsCount && (strncmp(*p, "-m32", 4) == 0 ||
- strncmp(*p, "-m64", 4) == 0 ||
- strncmp(*p, "-mabi", 5) == 0)) {
- /* Our command line sets the ABI, warn the user about this and ignore
- newArgs by setting newflagsCount to 0.
- */
- newflagsCount = 0;
- fprintf(stderr, "%s: gcc-wrapper: %s detected on the command line overrides implicit %s added by the wrapper.\n", argv[0], *p, newflagsStr);
- }
- }
-
- /* Allocate our array Make room for the original, new ones, and the
- NULL terminator */
- newargv = (char **)malloc(sizeof(char *) * (argc + newflagsCount + 1));
- if(!newargv)
- return NULL;
-
- /* Build argv */
- newargv[0] = argv[0];
-
- /* The newFlags come first since we want the environment to override them. */
- for(i=1; i - 1 < newflagsCount; i++) {
- newargv[i] = newflags[i - 1];
- }
-
- /* We just use the existing argv[i] as the start. */
- for(; i - newflagsCount < argc; i++) {
- newargv[i] = argv[i - newflagsCount];
- }
-
- /* And now cap it off... */
- newargv[i] = NULL;
-
- return newargv;
-}
-
-#define lastOfStr(str, n) ((str) + strlen(str) - (n))
-
-int main(int argc, char *argv[])
-{
- struct wrapper_data *data;
- size_t size;
- char *path;
- int result = 0;
- char **newargv = argv;
-
- data = alloca(sizeof(*data));
- if (data == NULL)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
- memset(data, 0, sizeof(*data));
-
- path = getenv("PATH");
- if (path != NULL) {
- data->path = strdup(getenv("PATH"));
- if (data->path == NULL)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
- }
-
- /* What should we find ? */
- strcpy(data->name, basename(argv[0]));
-
- /* cc calls "/full/path/to/gcc" ... */
- if (!strcmp(data->name, "cc"))
- strcpy(data->name, "gcc");
-
- /* What is the full name of our wrapper? */
- size = sizeof(data->fullname);
- result = snprintf(data->fullname, size, "/usr/bin/%s", data->name);
- if ((result == -1) || (result > size))
- wrapper_exit("invalid wrapper name: \"%s\"\n", data->name);
-
- find_wrapper_target(data);
-
- modify_path(data);
-
- if (data->path)
- free(data->path);
- data->path = NULL;
-
- /* Set argv[0] to the correct binary, else gcc can't find internal headers
- * http://bugs.gentoo.org/show_bug.cgi?id=8132 */
- argv[0] = data->bin;
-
- /* If this is g{cc,++}{32,64}, we need to add -m{32,64}
- * otherwise we need to add ${CFLAGS_${ABI}}
- */
- if(!strcmp(lastOfStr(data->bin, 2), "32") ) {
- data->bin[strlen(data->bin) - 2] = '\0';
- newargv = getNewArgv(argv, "-m32");
- } else if (!strcmp(lastOfStr(data->bin, 2), "64") ) {
- data->bin[strlen(data->bin) - 2] = '\0';
- newargv = getNewArgv(argv, "-m64");
- } else if(getenv("ABI")) {
- char *envar = (char *)malloc(sizeof(char) * (strlen("CFLAGS_") + strlen(getenv("ABI")) + 1 ));
- if(!envar)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
-
- /* We use CFLAGS_${ABI} for gcc, g++, g77, etc as they are
- * the same no matter which compiler we are using.
- */
- sprintf(envar, "CFLAGS_%s", getenv("ABI"));
-
- if(getenv(envar)) {
- newargv = getNewArgv(argv, getenv(envar));
- if(!newargv)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
- }
-
- free(envar);
- }
-
- /* Ok, do it ... */
- if (execv(data->bin, newargv) < 0)
- wrapper_exit("Could not run/locate \"%s\"\n", data->name);
-
- return 0;
-}
diff --git a/sys-devel/gcc-config/files/wrapper-1.4.6.c b/sys-devel/gcc-config/files/wrapper-1.4.6.c
deleted file mode 100644
index 5945b652c38a..000000000000
--- a/sys-devel/gcc-config/files/wrapper-1.4.6.c
+++ /dev/null
@@ -1,409 +0,0 @@
-/*
- * Copyright 1999-2005 Gentoo Foundation
- * Distributed under the terms of the GNU General Public License v2
- * $Header: /var/cvsroot/gentoo-x86/sys-devel/gcc-config/files/wrapper-1.4.6.c,v 1.4 2005/07/23 05:05:52 vapier Exp $
- * Author: Martin Schlemmer <azarah@gentoo.org>
- * az's lackey: Mike Frysinger <vapier@gentoo.org>
- */
-
-#define _REENTRANT
-#define _GNU_SOURCE
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <sys/types.h>
-#include <sys/stat.h>
-#include <sys/param.h>
-#include <unistd.h>
-#include <sys/wait.h>
-#include <libgen.h>
-#include <string.h>
-#include <stdarg.h>
-#include <errno.h>
-
-#define GCC_CONFIG "/usr/bin/gcc-config"
-#define ENVD_BASE "/etc/env.d/05gcc"
-
-struct wrapper_data {
- char name[MAXPATHLEN + 1];
- char fullname[MAXPATHLEN + 1];
- char bin[MAXPATHLEN + 1];
- char tmp[MAXPATHLEN + 1];
- char *path;
-};
-
-static const char *wrapper_strerror(int err, struct wrapper_data *data)
-{
- /* this app doesn't use threads and strerror
- * is more portable than strerror_r */
- strncpy(data->tmp, strerror(err), sizeof(data->tmp));
- return data->tmp;
-}
-
-static void wrapper_exit(char *msg, ...)
-{
- va_list args;
- fprintf(stderr, "gcc-config error: ");
- va_start(args, msg);
- vfprintf(stderr, msg, args);
- va_end(args);
- exit(1);
-}
-
-/* check_for_target checks in path for the file we are seeking
- * it returns 1 if found (with data->bin setup), 0 if not and
- * negative on error
- */
-static int check_for_target(char *path, struct wrapper_data *data)
-{
- struct stat sbuf;
- int result = 0;
- char str[MAXPATHLEN + 1];
- size_t len = strlen(path) + strlen(data->name) + 2;
-
- snprintf(str, len, "%s/%s", path, data->name);
-
- /* Stat possible file to check that
- * 1) it exist and is a regular file, and
- * 2) it is not the wrapper itself, and
- * 3) it is in a /gcc-bin/ directory tree
- */
- result = stat(str, &sbuf);
- if ((result == 0) && \
- ((sbuf.st_mode & S_IFREG) || (sbuf.st_mode & S_IFLNK)) && \
- (strcmp(str, data->fullname) != 0) && \
- (strstr(str, "/gcc-bin/") != 0)) {
-
- strncpy(data->bin, str, MAXPATHLEN);
- data->bin[MAXPATHLEN] = 0;
- result = 1;
- } else
- result = 0;
-
- return result;
-}
-
-static int find_target_in_path(struct wrapper_data *data)
-{
- char *token = NULL, *state;
- char str[MAXPATHLEN + 1];
-
- if (data->path == NULL) return 0;
-
- /* Make a copy since strtok_r will modify path */
- snprintf(str, MAXPATHLEN + 1, "%s", data->path);
-
- token = strtok_r(str, ":", &state);
-
- /* Find the first file with suitable name in PATH. The idea here is
- * that we do not want to bind ourselfs to something static like the
- * default profile, or some odd environment variable, but want to be
- * able to build something with a non default gcc by just tweaking
- * the PATH ... */
- while ((token != NULL) && strlen(token)) {
- if (check_for_target(token, data))
- return 1;
- token = strtok_r(NULL, ":", &state);
- }
-
- return 0;
-}
-
-/* find_target_in_envd parses /etc/env.d/05gcc, and tries to
- * extract PATH, which is set to the current profile's bin
- * directory ...
- */
-static int find_target_in_envd(struct wrapper_data *data, int cross_compile)
-{
- FILE *envfile = NULL;
- char *token = NULL, *state;
- char str[MAXPATHLEN + 1];
- char *strp = str;
- char envd_file[MAXPATHLEN + 1];
-
- if (!cross_compile) {
- snprintf(envd_file, MAXPATHLEN, "%s", ENVD_BASE);
- } else {
- char *ctarget, *end = strrchr(data->name, '-');
- if (end == NULL)
- return 0;
- ctarget = strdup(data->name);
- ctarget[end - data->name] = '\0';
- snprintf(envd_file, MAXPATHLEN, "%s-%s", ENVD_BASE, ctarget);
- free(ctarget);
- }
- envfile = fopen(envd_file, "r");
- if (envfile == NULL)
- return 0;
-
- while (0 != fgets(strp, MAXPATHLEN, envfile)) {
- /* Keep reading ENVD_FILE until we get a line that
- * starts with 'PATH='
- */
- if (((strp) && (strlen(strp) > strlen("PATH=")) &&
- !strncmp("PATH=", strp, strlen("PATH=")))) {
-
- token = strtok_r(strp, "=", &state);
- if ((token != NULL) && strlen(token))
- /* The second token should be the value of PATH .. */
- token = strtok_r(NULL, "=", &state);
- else
- goto bail;
-
- if ((token != NULL) && strlen(token)) {
- strp = token;
- /* A bash variable may be unquoted, quoted with " or
- * quoted with ', so extract the value without those ..
- */
- token = strtok(strp, "\n\"\'");
-
- while (token != NULL) {
- if (check_for_target(token, data)) {
- fclose(envfile);
- return 1;
- }
-
- token = strtok(NULL, "\n\"\'");
- }
- }
- }
- strp = str;
- }
-
-bail:
- fclose(envfile);
- return (cross_compile ? 0 : find_target_in_envd(data, 1));
-}
-
-static void find_wrapper_target(struct wrapper_data *data)
-{
- FILE *inpipe = NULL;
- char str[MAXPATHLEN + 1];
-
- if (find_target_in_path(data))
- return;
-
- if (find_target_in_envd(data, 0))
- return;
-
- /* Only our wrapper is in PATH, so
- get the CC path using gcc-config and
- execute the real binary in there... */
- inpipe = popen(GCC_CONFIG " --get-bin-path", "r");
- if (inpipe == NULL)
- wrapper_exit(
- "Could not open pipe: %s\n",
- wrapper_strerror(errno, data));
-
- if (fgets(str, MAXPATHLEN, inpipe) == 0)
- wrapper_exit(
- "Could not get compiler binary path: %s\n",
- wrapper_strerror(errno, data));
-
- strncpy(data->bin, str, sizeof(data->bin) - 1);
- data->bin[strlen(data->bin) - 1] = '/';
- strncat(data->bin, data->name, sizeof(data->bin) - 1);
- data->bin[MAXPATHLEN] = 0;
-
- pclose(inpipe);
-}
-
-/* This function modifies PATH to have gcc's bin path appended */
-static void modify_path(struct wrapper_data *data)
-{
- char *newpath = NULL, *token = NULL, *state;
- char dname_data[MAXPATHLEN + 1], str[MAXPATHLEN + 1];
- char *str2 = dname_data, *dname = dname_data;
- size_t len = 0;
-
- if (data->bin == NULL)
- return;
-
- snprintf(str2, MAXPATHLEN + 1, "%s", data->bin);
-
- if ((dname = dirname(str2)) == NULL)
- return;
-
- if (data->path == NULL)
- return;
-
- /* Make a copy since strtok_r will modify path */
- snprintf(str, MAXPATHLEN + 1, "%s", data->path);
-
- token = strtok_r(str, ":", &state);
-
- /* Check if we already appended our bin location to PATH */
- if ((token != NULL) && strlen(token)) {
- if (!strcmp(token, dname))
- return;
- }
-
- len = strlen(dname) + strlen(data->path) + 2 + strlen("PATH") + 1;
-
- newpath = (char *)malloc(len);
- if (newpath == NULL)
- wrapper_exit("out of memory\n");
- memset(newpath, 0, len);
-
- snprintf(newpath, len, "PATH=%s:%s", dname, data->path);
- putenv(newpath);
-}
-
-#define MAXNEWFLAGS 32
-#define MAXFLAGLEN 127
-
-static char **getNewArgv(char **argv, const char *newflagsStr) {
- char **newargv;
- char newflags[MAXNEWFLAGS][MAXFLAGLEN + 1];
- unsigned newflagsCount = 0;
- unsigned argc;
- unsigned i;
- char **p;
-
- unsigned s, f; /* start/finish of each flag. f points to
- * the char AFTER the end (ie the space/\0
- */
-
- /* Tokenize the flag list */
- for(s=0; s < strlen(newflagsStr); s=f+1) {
- /* Put s at the start of the next flag */
- while(newflagsStr[s] == ' ' ||
- newflagsStr[s] == '\t')
- s++;
- if(s == strlen(newflagsStr))
- break;
-
- f = s + 1;
- while(newflagsStr[f] != ' ' &&
- newflagsStr[f] != '\t' &&
- newflagsStr[f] != '\0')
- f++;
-
- /* Detect overrun */
- if(MAXFLAGLEN < f - s || MAXNEWFLAGS == newflagsCount)
- return NULL;
-
- strncpy(newflags[newflagsCount], newflagsStr + s, f - s);
- newflags[newflagsCount][f - s]='\0';
- newflagsCount++;
- }
-
- /* Calculate original argc and see if it contains -m{abi,32,64} */
- for(argc=0, p=argv; *p; p++, argc++) {
- if(newflagsCount && (strncmp(*p, "-m32", 4) == 0 ||
- strncmp(*p, "-m64", 4) == 0 ||
- strncmp(*p, "-mabi", 5) == 0)) {
- /* Our command line sets the ABI, warn the user about this and ignore
- * newArgs by setting newflagsCount to 0.
- */
- newflagsCount = 0;
- }
- }
-
- /* Allocate our array Make room for the original, new ones, and the
- NULL terminator */
- newargv = (char **)malloc(sizeof(char *) * (argc + newflagsCount + 1));
- if(!newargv)
- return NULL;
-
- /* Build argv */
- newargv[0] = argv[0];
-
- /* The newFlags come first since we want the environment to override them. */
- for(i=1; i - 1 < newflagsCount; i++) {
- newargv[i] = newflags[i - 1];
- }
-
- /* We just use the existing argv[i] as the start. */
- for(; i - newflagsCount < argc; i++) {
- newargv[i] = argv[i - newflagsCount];
- }
-
- /* And now cap it off... */
- newargv[i] = NULL;
-
- return newargv;
-}
-
-int main(int argc, char *argv[])
-{
- struct wrapper_data *data;
- size_t size;
- char *path;
- int result = 0;
- char **newargv = argv;
-
- data = alloca(sizeof(*data));
- if (data == NULL)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
- memset(data, 0, sizeof(*data));
-
- path = getenv("PATH");
- if (path != NULL) {
- data->path = strdup(getenv("PATH"));
- if (data->path == NULL)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
- }
-
- /* What should we find ? */
- strcpy(data->name, basename(argv[0]));
-
- /* cc calls "/full/path/to/gcc" ... */
- if (!strcmp(data->name, "cc"))
- strcpy(data->name, "gcc");
- if (!strcmp(data->name, "f77"))
- data->name[0] = 'g';
-
- /* What is the full name of our wrapper? */
- size = sizeof(data->fullname);
- result = snprintf(data->fullname, size, "/usr/bin/%s", data->name);
- if ((result == -1) || (result > size))
- wrapper_exit("invalid wrapper name: \"%s\"\n", data->name);
-
- find_wrapper_target(data);
-
- modify_path(data);
-
- if (data->path)
- free(data->path);
- data->path = NULL;
-
- /* Set argv[0] to the correct binary, else gcc can't find internal headers
- * http://bugs.gentoo.org/show_bug.cgi?id=8132 */
- argv[0] = data->bin;
-
- /* If this is g{cc,++}{32,64}, we need to add -m{32,64}
- * otherwise we need to add ${CFLAGS_${ABI}}
- */
- size = strlen(data->bin) - 2;
- if(!strcmp(data->bin + size, "32") ) {
- *(data->bin + size) = '\0';
- newargv = getNewArgv(argv, "-m32");
- } else if (!strcmp(data->bin + size, "64") ) {
- *(data->bin + size) = '\0';
- newargv = getNewArgv(argv, "-m64");
- } else if(getenv("ABI")) {
- char *envar = (char *)malloc(sizeof(char) * (strlen("CFLAGS_") + strlen(getenv("ABI")) + 1 ));
- if(!envar)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
-
- /* We use CFLAGS_${ABI} for gcc, g++, g77, etc as they are
- * the same no matter which compiler we are using.
- */
- sprintf(envar, "CFLAGS_%s", getenv("ABI"));
-
- if(getenv(envar)) {
- newargv = getNewArgv(argv, getenv(envar));
- if(!newargv)
- wrapper_exit("%s wrapper: out of memory\n", argv[0]);
- }
-
- free(envar);
- }
-
- /* Ok, do it ... */
- if (execv(data->bin, newargv) < 0)
- wrapper_exit("Could not run/locate \"%s\"\n", data->name);
-
- return 0;
-}